freeslot("sfx_dtnbom")
sfxinfo[sfx_dtnbom].caption = "Explosion Jump"

local sparks = function(inflictor, ns)
	P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, MT_SPARK)
	local i = 0
	while i < 15
		local fa = (i*(ANGLE_180/8))
		local mo = P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, MT_SUPERSPARK)
		if mo and mo.valid
			mo.momy = FixedMul(cos(fa),ns)
			mo.momx = FixedMul(sin(fa),ns)
		end
		i = $+1
	end
end

local jumpnuke = function(inflictor, source, radius)
	for mo in mobjs.iterate()
		if not (mo and mo.valid and mo.health)
			continue
		end
		if not (mo.flags & MF_SHOOTABLE) and not (mo.type == MT_EGGGUARD or mo.type == MT_MINUS
		or mo.type == MT_SPIKE or mo.type == MT_WALLSPIKE)
			continue
		end
		if mo.type == MT_PLAYER and not G_RingSlingerGametype()
			continue // Don't hurt players in Co-Op
		end
		if abs(inflictor.x - mo.x) > radius or abs(inflictor.y - mo.y) > radius or abs(inflictor.z - mo.z) > radius
			continue
		end
		if P_AproxDistance(P_AproxDistance(inflictor.x - mo.x, inflictor.y - mo.y), inflictor.z - mo.z) > radius
			continue
		end
		if mo.type == MT_MINUS and not (mo.flags & (MF_SPECIAL|MF_SHOOTABLE))
			mo.flags = (mo.flags & ~MF_NOCLIPTHING)|MF_SPECIAL|MF_SHOOTABLE
		end
		if mo.type == MT_SPIKE or mo.type == MT_WALLSPIKE
			P_KillMobj(mo, inflictor, source, DMG_NUKE) //just murder spikes!
		end
		//Unlike the orignal script this always deals one damage, no matter what
		P_DamageMobj(mo, inflictor, source, 1, DMG_NUKE)
	end
end


addHook("PreThinkFrame", function()
	if srb2p return end //stop breaking my persona >:(
	for p in players.iterate
		if p and p.mo
			if (p.mo.skin == "deton") and (p.playerstate == PST_LIVE)			
				//variables
				if p.detonjumped == nil
				or (P_IsObjectOnGround(p.mo))
					p.detonjumped = 0 
				end
				
				if p.detonhold == nil
				or not (p.cmd.buttons & BT_SPIN)
					p.detonhold = 0
				end
				
				if P_IsObjectOnGround(p.mo) 
				and (p.cmd.buttons & BT_SPIN) 
				or p.rings >= 50 and not p.powers[pw_super] and All7Emeralds(emeralds) //prevent transforming doing a bad
					p.detonhold = 1 
				end
				
				//the jump part
				if (p.cmd.buttons & BT_SPIN)
				and p.detonjumped == 0
				and not (P_IsObjectOnGround(p.mo))
				and (p.pflags & PF_JUMPED)
				and p.detonhold == 0
				and not p.powers[pw_carry]
				and not (p.mo.tracer and p.mo.tracer.type == MT_TUBEWAYPOINT)
				and not (p.pflags & PF_THOKKED)
				and not (P_PlayerInPain(p))
				and not (p.exiting)
					if p.isxmomentum
						if p.powers[pw_super]
							P_SetObjectMomZ(p.mo, (p.speed / 7) + 19*FRACUNIT)
							jumpnuke(p.mo, p.mo, 240*FRACUNIT)
						else
							P_SetObjectMomZ(p.mo, (p.speed / 7) + 14*FRACUNIT)
							jumpnuke(p.mo, p.mo, 180*FRACUNIT)
						end
						if p.hyper and p.hyper.capable and p.powers[pw_super]
							P_SetObjectMomZ(p.mo, (p.speed / 7) + 25*FRACUNIT)
							jumpnuke(p.mo, p.mo, 500*FRACUNIT)
							S_StartSound(deton, sfx_brakrx)
							P_FlashPal(p, PAL_WHITE, 10)
						end
					else
						if p.powers[pw_super]
							P_SetObjectMomZ(p.mo, 19*FRACUNIT)
							jumpnuke(p.mo, p.mo, 240*FRACUNIT)
						else
							P_SetObjectMomZ(p.mo, 14*FRACUNIT)
							jumpnuke(p.mo, p.mo, 180*FRACUNIT)
						end
					end
					p.pflags = $|PF_THOKKED
					p.pflags = $1 & ~PF_JUMPED
					p.pflags = $1 & ~PF_SPINNING
					sparks(p.mo, 10 << FRACBITS)
					S_StartSound(p.mo, sfx_dtnbom)
					p.detonjumped = 1
					p.detonhold = 1
					p.mo.state = S_PLAY_SPRING
				end
			end
		end
		
		//carry
		if not (P_PlayerInPain(p))
		and not P_IsObjectOnGround(p.mo) 
		and p.mo.state == S_PLAY_FLOAT
			p.pflags = $1|PF_CANCARRY
		end
		//stop carrying
		if P_IsObjectOnGround(p.mo) 
		and (p.pflags & PF_CANCARRY)
		or (P_PlayerInPain(p))
			p.pflags = $1 & ~PF_CANCARRY
		end
	end
end)